﻿Public Class Form1

    Private m_cFileCopyCore As FileCopyCoreEx

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me

        m_cFileCopyCore = New FileCopyCoreEx()
        ' Source 경로의 파일을 dest 경로로 복사하되 FileOverWrite의 속성값이 True인 경우
        ' 동일 이름의 파일을 덮어쓰기. False인 경우 덮어쓰기 하지 않기
        m_cFileCopyCore.FileOverWrite = False
    End Sub

    ' 프로그램 종료
    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        SmartForm1.Close()
    End Sub

    Private Sub btnStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStart.Click
        ' 원본 경로
        Dim strSrcFile As String = "Flash Disk\\Src\\"

        ' 목적지(파일이 복사된) 경로
        Dim strDestFile As String = "하드 디스크\\Test\\Dest\\"

        ' FailList 초기화
        lstCopyFailList.ClearAll()

        ' 전체 파일 String 배열(Array) 선언
        Dim strAllFileList As String() = New String(4) {}

        Dim strCopyFailList As String()

        ' out 매개변수로 사용되어 선언만하고 초기화 필요없음
        Dim iSuccessCnt As Integer

        ' 복사할 원본 파일들을 배열(Array)에 순차적으로 저장
        strAllFileList(0) = "test.txt"
        strAllFileList(1) = "test.cs"
        strAllFileList(2) = "test.png"
        strAllFileList(3) = "test.exe"
        strAllFileList(4) = "test.docx"

        ' 인자로는 SrcFile : 원본 경로, DestFile : 목적지 경로, filelist : 파일 리스트, iRetryCnt : 파일 복사 재시도 횟수, iSuccessCnt : 복사 성공카운트
        ' iSuccessCnt는 메서드 내부에서 변경된 값을 참조하기위해 out파라미터로 선언
        strCopyFailList = m_cFileCopyCore.FileCopyRetry(strSrcFile, strDestFile, strAllFileList, Convert.ToInt32(udRetryCount.Value), iSuccessCnt)

        ' 파일 복사시 복사가 실패한 리스트가 있으면
        If strCopyFailList IsNot Nothing Then
            ' 실패한 리스트를 리스트박에서 추가
            For Each value As String In strCopyFailList
                lstCopyFailList.AddItem(value)
            Next
        End If

        ' 파일의 총 개수
        labFileCount.Text = strAllFileList.Length.ToString()
        ' 복사 성공 횟수
        labSuccessCount.Text = iSuccessCnt.ToString()
        ' 복사 실패 횟수
        labFailCount.Text = (strAllFileList.Length - iSuccessCnt).ToString()
    End Sub
End Class
